// 使用自定义函数解析查询字符串并返回参数对象
function util_getCurrentUrlQueryStringParams() {
    // 获取当前URL的查询字符串部分
    var queryString = window.location.search;
    var params = {};
    // 移除开头的问号
    queryString = queryString.substring(1);
    // 分割成键值对数组
    var keyValuePairs = queryString.split('&');
    // 遍历键值对数组，将每一对分割成键和值，并存入params对象
    keyValuePairs.forEach(function(keyValuePair) {
        var pair = keyValuePair.split('=');
        var key = decodeURIComponent(pair[0]);
        var value = decodeURIComponent(pair[1] || '');
        params[key] = value;
    });
    return params;
}

async function fetch_request(url){
     console.log('fetch request url:'+url);
     var return_html = '';
     let options = {
         method: 'get',
         headers: {
             'Content-Type':'application/json;charset=utf-8'
         },
         // body: JSON.stringify(res)
     }
     // Fake api for making post requests
    //console.log('fetch_request url:'+url);
    await fetch(url,options)
        .then(res => res.text())
        .then(d => {
            //403错误也是直接到这里了
            console.log('post response:');
            //console.log(d);
            return_html = d;
        }).catch(function (){
            console.log('fetch_request error url:'+url);
            return_html = '';
        })
    return return_html;
}
//搜索 没用
function shangjia_search_caiji(){
    setTimeout(function (){
        var message = {
            action: 'can_list_caiji',
            info: ''
        };
        chrome.runtime.sendMessage(message,(msg)=>{
            console.log('can_list_caiji 答复',msg)
            let msgobj  = JSON.parse(msg);
            console.log(msgobj['state']);
            if(msgobj['state'] == 0){ //可以自动采集
                console.log('list采集已开启');
                //
                console.log('shangjia_search_caiji');
                let current_url = window.location.href;
                if(current_url) {
                    //找供应商company/company_search
                    if (current_url.indexOf('search?cate') != -1) {
                        var shangjia_infos = [];
                        console.log('shangjia_search_caiji a2');
                        $("style[data-testid='beast-core-ellipsis-style']").remove();
                        $(".goods-list .goods-item").each(function (){
                            console.log('shangjia_search_caiji a3');
                            let _shangjia_name = '';
                            let _shangjia_contact_info_url = '';
                            let _shangjia_business = '';
                            let _shangjia_product = '';
                            let _shangjia_company_type = '';
                            let _shangjia_city = '';
                            let _shangjia_cheng_year = '';

                            let _shangjia_a_link = $(this).find('a.goods-cont').attr('href');
                            if(_shangjia_a_link){
                                let _shangjia_product_link = '';
                                if(_shangjia_a_link.indexOf('?')!=-1){
                                    let _shangjia_a_link_arr = _shangjia_a_link.split('?');
                                    _shangjia_product_link = _shangjia_a_link_arr[0];
                                    let _shangjia_a_link_args = _shangjia_a_link_arr[1];
                                    let _shangjia_a_link_args_arr = _shangjia_a_link_args.split('&');
                                    let _gid_arg = _shangjia_a_link_args_arr[0];
                                    _shangjia_product_link +='?'+_gid_arg;
                                    _shangjia_product_link = 'https://pifa.pinduoduo.com'+_shangjia_product_link;
                                }
                                if(_shangjia_product_link){
                                    //
                                    _shangjia_name = $(this).find('.goods-name').text();
                                    _shangjia_name = _shangjia_name.trim();
                                    //
                                    let _shangjia_info = {
                                        '_shangjia_id': _shangjia_product_link,
                                        '_shangjia_a_link':_shangjia_product_link,
                                        '_shangjia_name': _shangjia_name,
                                    };
                                    //console.log(_shangjia_info);
                                    shangjia_infos.push(_shangjia_info);
                                    //
                                }

                            }
                        });
                        //
                        var message = {
                            action: 'shangjia_items_update',
                            info: '',
                            shangjia_infos: shangjia_infos
                        };
                        send_message_to_popup(message);
                        //处理自动化采集
                        //zidong_caiji_next();
                        //
                    }
                }
                //
            }else{
                console.log('list采集已关闭')
            }
        })
    },1000);
}

//货源、工业品采集
function shangjia_search_huoyuan_caiji(){
    setTimeout(function (){
        var message = {
            action: 'can_list_caiji',
            info: ''
        };
        chrome.runtime.sendMessage(message,(msg)=> {
            console.log('can_list_caiji 答复', msg)
            let msgobj = JSON.parse(msg);
            console.log(msgobj['state']);
            if (msgobj['state'] == 0) { //可以自动采集
                //
                console.log('shangjia_search_huoyuan_caiji');
                let current_url = window.location.href;
                if(current_url) {
                    //找货源selloffer/offer_search
                    if (current_url.indexOf('selloffer/offer_search') != -1 || current_url.indexOf('selloffer/imall_search') != -1) {
                        var shangjia_infos = [];
                        console.log('shangjia_search_huoyuan_caiji a2');
                        $("#sm-offer-list .space-offer-card-box").each(function (){
                            console.log('shangjia_search_caiji a3');
                            let _shangjia_name = '';
                            let _shangjia_contact_info_url = '';
                            let _shangjia_business = '';
                            let _shangjia_product = '';
                            let _shangjia_company_type = '';
                            let _shangjia_city = '';
                            let _shangjia_cheng_year = '';
                            let _shangjia_product_link = '';
                            let _shangjia_id = '';
                            //
                            let _shangjia_a_link = $(this).find('.mojar-element-title a').attr('href');
                            if(_shangjia_a_link && _shangjia_a_link.indexOf('detail')!=-1){
                                let _shangjia_product_link = '';
                                if(_shangjia_a_link.indexOf('?')!=-1){
                                    let _shangjia_a_link_arr = _shangjia_a_link.split('?');
                                    _shangjia_product_link = _shangjia_a_link_arr[0];
                                }else{
                                    _shangjia_product_link = _shangjia_a_link;
                                }
                                _shangjia_id = _shangjia_product_link.replace('https://detail.1688.com/offer/','')
                                    .replace('.html','');
                                _shangjia_name = $(this).find('.mojar-element-title a .title').text();

                                let _shangjia_info = {
                                    '_shangjia_id': _shangjia_id,
                                    '_shangjia_a_link':_shangjia_product_link,
                                    '_shangjia_name': _shangjia_name,
                                };
                                //console.log(_shangjia_info);
                                shangjia_infos.push(_shangjia_info);
                                //
                            }
                        });
                        //
                        var message = {
                            action: 'shangjia_items_update',
                            info: '',
                            shangjia_infos: shangjia_infos
                        };
                        send_message_to_popup(message);
                    }
                }
                //
            }else{
                console.log('list采集已关闭')
            }
        })
    },1000);
}

//卖家商品采集
//不支持
//找工厂
function shangjia_search_gongchang_caiji(companyInfoSearchDataServiceUrl=''){
    console.log('shangjia_search_caiji');
    let current_url = window.location.href;
    if(current_url) {
        //找供应商company/company_search
        if (current_url.indexOf('company/pc/factory_search') != -1) {
            //
            let return_html = fetch_request(companyInfoSearchDataServiceUrl);
            return_html.then((data) => {
                if(data){
                    console.log('shangjia_search_gongchang_caiji fetch data');
                    //console.log(data);
                    let data_json = JSON.parse(data);
                    console.log(data_json);
                    //
                    var shangjia_infos = [];
                    if(data_json['data']['code'] = 200){
                        let gongchang_items_data = data_json['data']['data']['companyWithOfferLists'];
                        for(let i=0;i<gongchang_items_data.length;i++){
                            let factoryInfo = gongchang_items_data[i]['factoryInfo'];
                            let recommendWords = factoryInfo['recommendWords'];
                            let recommendWords_str = recommendWords.join(', ');
                            let _shangjia_info = {
                                '_shangjia_id': factoryInfo['company'],
                                '_shangjia_a_link':'',
                                '_factoryDetailUrl':factoryInfo['factoryDetailUrl'],
                                '_shangjia_name': factoryInfo['company'],
                                '_shangjia_company_type':'工厂',
                                '_shangjia_business':recommendWords_str,
                                '_shangjia_product':factoryInfo['productionService'],
                                '_shangjia_city': factoryInfo['city'],
                                '_shangjia_cheng_year':factoryInfo['tpServiceYear']
                            };
                            //console.log(_shangjia_info);
                            shangjia_infos.push(_shangjia_info);
                        }
                        var message = {
                            action: 'shangjia_items_update',
                            info: '',
                            shangjia_infos: shangjia_infos
                        };
                        send_message_to_popup(message);
                    }
                    //
                }else{
                    //对于访问异常的请求,直接过滤

                }
            });
        }
    }
}

function zidong_caiji_next(){
    util_currentpage_scrollToBottomWithCallback(function (){
        console.log('zidong_caiji_next s');
        let seemore_dom =  $(".fui-paging-list .fui-next");
        var message = {
            action: 'can_zidong_caiji',
            info: ''
        };
        chrome.runtime.sendMessage(message,(msg)=>{
            console.log('zidong_caiji_next 答复',msg)
            let msgobj  = JSON.parse(msg);
            console.log(msgobj['state']);
            if(msgobj['state'] == 0){ //可以自动采集
                console.log('zidong_caiji_next s2');
                //
                seemore_dom.click();
                //
            }
        })
    });
}

function util_timeConsumingFunction(seconds) {
  // 将秒数转换为毫秒
  const milliseconds = seconds * 1000;

  // 模拟耗时操作，例如循环计算
  const startTime = new Date().getTime();
  while (new Date().getTime() - startTime < milliseconds) {
    // 一些计算
  }
}

var navigation_url = '';
function perf_observer(list, obserer){
    //console.log('aa');
    //console.log(getNetworkRequests(list.getEntriesByType('resource')));
    performanceResourceList = list.getEntriesByType('resource');
    //console.log(performanceResourceList);
    for(i = 0; i<performanceResourceList.length; i++){
        performanceResourceItem = performanceResourceList[i];
        //console.log('abababa');
        //console.log(performanceResourceItem);
       if(performanceResourceItem['initiatorType'] == 'fetch'){
            //找供应商
            if(performanceResourceItem['name'].indexOf('service/companySearchBusinessService')!=-1){
                //console.log(performanceResourceItem['name']);
               /* console.log('bbbb'+performanceResourceItem['name']);
                //
                setTimeout(function() {
                    shangjia_search_caiji();
                }, 1000);*/
                //找工厂
            }else if(performanceResourceItem['name'].indexOf('service/companyInfoSearchDataService')!=-1){
                 //console.log(performanceResourceItem['name']);
                console.log('bbbb'+performanceResourceItem['name']);
                //
                /*let companyInfoSearchDataServiceUrl = performanceResourceItem['name'];
                 setTimeout(function() {
                    shangjia_search_gongchang_caiji(companyInfoSearchDataServiceUrl);
                }, 1000);*/
                //找货源、工业品
            }else if(performanceResourceItem['name'].indexOf('service/marketOfferResultViewService') !=-1) {
                console.log('bbbb' + performanceResourceItem['name']);
                //
                setTimeout(function () {
                    shangjia_search_huoyuan_caiji();
                }, 2000);
            }
        }else if(performanceResourceItem['initiatorType'] == 'xmlhttprequest'){
            if(performanceResourceItem['name'].indexOf('mtop.1688.shop.data.get') !=-1) {
                console.log('bbbb' + performanceResourceItem['name']);
                //卖家商品列表

            }
       }
    }
    //////
    /*performanceNavigationList = list.getEntriesByType('navigation');
    for(i = 0; i<performanceNavigationList.length; i++) {
        performanceNavigationItem = performanceNavigationList[i];
        if (performanceNavigationItem['initiatorType'] == 'navigation') {
            navigation_url = performanceNavigationItem['name']
        }
    }*/
}
var observer_ = new PerformanceObserver(perf_observer);
//observer_.observe({entryTypes:['resource', 'navigation']});
observer_.observe({entryTypes:['resource', 'navigation', 'paint']});
//

function exportToCsv(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".csv");
}

function exportToExcel(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".xlsx");
}

function export_normal_xlsx_output(need_item){
    let export_datas = [];
    //
    if (true) {
        let shangjia_about_contact_and_basic_info = need_item;
        let _shangjia_goodsId = shangjia_about_contact_and_basic_info['_shangjia_goodsId']
        let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
        let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

        let futu1 = '';
        let futu2 = '';
        let futu3 = '';
        let futu4 = '';
        let futu5 = '';

        let futu6 = '';
        let futu7 = '';
        let futu8 = '';
        let futu9 = '';
        let futu10 = '';

        let futu11 = '';
        let futu12 = '';
        let futu13 = '';
        let futu14 = '';
        let futu15 = '';

        let futu16 = '';
        let futu17 = '';
        let futu18 = '';
        let futu19 = '';
        let futu20 = '';

        if(_shangjia_gallery_arr.length>=1){
            futu1 = _shangjia_gallery_arr[0];
        }
        if(_shangjia_gallery_arr.length>=2){
            futu2 = _shangjia_gallery_arr[1];
        }
        if(_shangjia_gallery_arr.length>=3){
            futu3 = _shangjia_gallery_arr[2];
        }
        if(_shangjia_gallery_arr.length>=4){
            futu4 = _shangjia_gallery_arr[3];
        }
        if(_shangjia_gallery_arr.length>=5){
            futu5 = _shangjia_gallery_arr[4];
        }
        if(_shangjia_gallery_arr.length>=6){
            futu6 = _shangjia_gallery_arr[5];
        }
        if(_shangjia_gallery_arr.length>=7){
            futu7 = _shangjia_gallery_arr[6];
        }
        if(_shangjia_gallery_arr.length>=8){
            futu8 = _shangjia_gallery_arr[7];
        }
        if(_shangjia_gallery_arr.length>=9){
            futu9 = _shangjia_gallery_arr[8];
        }
        if(_shangjia_gallery_arr.length>=10){
            futu10 = _shangjia_gallery_arr[9];
        }
        if(_shangjia_gallery_arr.length>=11){
            futu11 = _shangjia_gallery_arr[10];
        }
        if(_shangjia_gallery_arr.length>=12){
            futu12 = _shangjia_gallery_arr[11];
        }
        if(_shangjia_gallery_arr.length>=13){
            futu13 = _shangjia_gallery_arr[12];
        }
        if(_shangjia_gallery_arr.length>=14){
            futu14 = _shangjia_gallery_arr[13];
        }
        if(_shangjia_gallery_arr.length>=15){
            futu15 = _shangjia_gallery_arr[14];
        }
        if(_shangjia_gallery_arr.length>=16){
            futu16 = _shangjia_gallery_arr[15];
        }
        if(_shangjia_gallery_arr.length>=17){
            futu17 = _shangjia_gallery_arr[16];
        }
        if(_shangjia_gallery_arr.length>=18){
            futu18 = _shangjia_gallery_arr[17];
        }
        if(_shangjia_gallery_arr.length>=19){
            futu19 = _shangjia_gallery_arr[18];
        }
        if(_shangjia_gallery_arr.length>=20){
            futu20 = _shangjia_gallery_arr[19];
        }
        //
        let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
        //
        let _shangjia_product_link = '';
        let _shangjia_a_link = window.location.href;
        if(_shangjia_a_link.indexOf('?')!=-1){
            let _shangjia_a_link_arr = _shangjia_a_link.split('?');
            _shangjia_product_link = _shangjia_a_link_arr[0];
            let _shangjia_a_link_args = _shangjia_a_link_arr[1];
            let _shangjia_a_link_args_arr = _shangjia_a_link_args.split('&');
            let _gid_arg = _shangjia_a_link_args_arr[0];
            _shangjia_product_link +='?'+_gid_arg;
        }
        //
        for(let i=0;i<_shangjia_variants_skus.length;i++){
            //
            let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
            let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
            let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
            let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
            //
            let export_data_item = {
                '产品url': shangjia_about_contact_and_basic_info['_shangjia_product_link'],
                'SKU': shangjia_about_contact_and_basic_info['_shangjia_goodsId'],
                //'原变体SKU': _shangjia_variants_skus[i]['skuId'],
                '变体带属性SKU': _shangjia_variants_skus[i]['subsku'],
                '产品标题': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
                //'Category': shangjia_about_contact_and_basic_info['_shangjia_category'],
                '变体图片': _shangjia_variants_skus[i]['img'],
                '价格': _shangjia_variants_skus[i]['normalPriceStr'],
                '原价': _shangjia_variants_skus[i]['normalLinePriceStr'],
                '变体库存': _shangjia_variants_skus[i]['stockQuantity'],
                '属性1名': specs_key1_name?specs_key1_name:specs_key2_name,
                '属性1值': specs_key1_name?_shangjia_variants_skus[i]['specs_key1_value']:_shangjia_variants_skus[i]['specs_key2_value'],
                '属性2名': specs_key1_name?specs_key2_name:'',
                '属性2值': specs_key1_name?_shangjia_variants_skus[i]['specs_key2_value']:'',
                //'属性3名': specs_key3_name,
                //'属性3值': _shangjia_variants_skus[i]['specs_key3_value'],
                //'属性4名': specs_key4_name,
                //'属性4值': _shangjia_variants_skus[i]['specs_key4_value'],
                '主图': shangjia_about_contact_and_basic_info['_shangjia_hdThumbUrl'],
                '附图1': futu1,
                '附图2': futu2,
                '附图3': futu3,
                '附图4': futu4,
                '附图5': futu5,
                '附图6': futu6,
                '附图7': futu7,
                '附图8': futu8,
                '附图9': futu9,
                '附图10': futu10,
                '附图11': futu11,
                '附图12': futu12,
                '附图13': futu13,
                '附图14': futu14,
                '附图15': futu15,
                '附图16': futu16,
                '附图17': futu17,
                '附图18': futu18,
                '附图19': futu19,
                '附图20': futu20,
                'VideoUrl': shangjia_about_contact_and_basic_info['_shangjia_VideoUrl'],
                '产品属性': shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'],
                '产品描述': shangjia_about_contact_and_basic_info['_shangjia_desc'],
                '描述图片': shangjia_about_contact_and_basic_info['_shangjia_productDetailFlatList'].join(','),
                //review
                'review': shangjia_about_contact_and_basic_info['_shangjia_reivew_num'],
                'sold': _shangjia_sold,
                //
                //'is request': shangjia_about_contact_and_basic_info['_is_request'] == 2 ? '已完成':'未',
            }
            export_datas.push(export_data_item);
            //
        }
        exportToExcel(export_datas, 'gycharm-1688-normal-export-'+_shangjia_goodsId, "Sheet1");
    }
}

function export_shopify_csv_output(need_item){
    let export_datas = [];
    //
    if (true) {
        let shangjia_about_contact_and_basic_info = need_item;
        let _shangjia_goodsId = shangjia_about_contact_and_basic_info['_shangjia_goodsId']
        //
        let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
        //
        let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

        let futu1 = '';
        let futu2 = '';
        let futu3 = '';
        let futu4 = '';
        let futu5 = '';

        let futu6 = '';
        let futu7 = '';
        let futu8 = '';
        let futu9 = '';
        let futu10 = '';

        let futu11 = '';
        let futu12 = '';
        let futu13 = '';
        let futu14 = '';
        let futu15 = '';

        let futu16 = '';
        let futu17 = '';
        let futu18 = '';
        let futu19 = '';
        let futu20 = '';

        if(_shangjia_gallery_arr.length>=1){
            futu1 = _shangjia_gallery_arr[0];
        }
        if(_shangjia_gallery_arr.length>=2){
            futu2 = _shangjia_gallery_arr[1];
        }
        if(_shangjia_gallery_arr.length>=3){
            futu3 = _shangjia_gallery_arr[2];
        }
        if(_shangjia_gallery_arr.length>=4){
            futu4 = _shangjia_gallery_arr[3];
        }
        if(_shangjia_gallery_arr.length>=5){
            futu5 = _shangjia_gallery_arr[4];
        }
        if(_shangjia_gallery_arr.length>=6){
            futu6 = _shangjia_gallery_arr[5];
        }
        if(_shangjia_gallery_arr.length>=7){
            futu7 = _shangjia_gallery_arr[6];
        }
        if(_shangjia_gallery_arr.length>=8){
            futu8 = _shangjia_gallery_arr[7];
        }
        if(_shangjia_gallery_arr.length>=9){
            futu9 = _shangjia_gallery_arr[8];
        }
        if(_shangjia_gallery_arr.length>=10){
            futu10 = _shangjia_gallery_arr[9];
        }
        if(_shangjia_gallery_arr.length>=11){
            futu11 = _shangjia_gallery_arr[10];
        }
        if(_shangjia_gallery_arr.length>=12){
            futu12 = _shangjia_gallery_arr[11];
        }
        if(_shangjia_gallery_arr.length>=13){
            futu13 = _shangjia_gallery_arr[12];
        }
        if(_shangjia_gallery_arr.length>=14){
            futu14 = _shangjia_gallery_arr[13];
        }
        if(_shangjia_gallery_arr.length>=15){
            futu15 = _shangjia_gallery_arr[14];
        }
        if(_shangjia_gallery_arr.length>=16){
            futu16 = _shangjia_gallery_arr[15];
        }
        if(_shangjia_gallery_arr.length>=17){
            futu17 = _shangjia_gallery_arr[16];
        }
        if(_shangjia_gallery_arr.length>=18){
            futu18 = _shangjia_gallery_arr[17];
        }
        if(_shangjia_gallery_arr.length>=19){
            futu19 = _shangjia_gallery_arr[18];
        }
        if(_shangjia_gallery_arr.length>=20){
            futu20 = _shangjia_gallery_arr[19];
        }
        //
        let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
        //
        let _body_html = shangjia_about_contact_and_basic_info['_shangjia_goodsProperty']+shangjia_about_contact_and_basic_info['_shangjia_desc'];
        /*let _shangjia_productDetailFlatList = shangjia_about_contact_and_basic_info['_shangjia_productDetailFlatList'];
        let _shangjia_productDetailFlatList_html = '';
        for(_f=0;_f<_shangjia_productDetailFlatList.length;_f++){
            _shangjia_productDetailFlatList_html += "<img src='"+_shangjia_productDetailFlatList[_f]+"' />";
        }
        _body_html += "<br />"+_shangjia_productDetailFlatList_html;*/
        //
        let _Handle = 'goods-detail-'+need_item['_shangjia_goodsId'];
        for(let i=0;i<_shangjia_variants_skus.length;i++){
            //
            let imgsrc = '';
            if(i==0){
                imgsrc = futu1;
            }else if(i==1){
                imgsrc = futu2;
            }else if(i==2){
                imgsrc = futu3;
            }else if(i==3){
                imgsrc = futu4;
            }else if(i==4){
                imgsrc = futu5;
            }else if(i==5){
                imgsrc = futu6;
            }else if(i==6){
                imgsrc = futu7;
            }else if(i==7){
                imgsrc = futu8;
            }else if(i==8){
                imgsrc = futu9;
            }else if(i==9){
                imgsrc = futu10;
            }else if(i==10){
                imgsrc = futu11;
            }else if(i==11){
                imgsrc = futu12;
            }else if(i==12){
                imgsrc = futu13;
            }else if(i==13){
                imgsrc = futu14;
            }else if(i==14){
                imgsrc = futu15;
            }else if(i==15){
                imgsrc = futu16;
            }else if(i==16){
                imgsrc = futu17;
            }else if(i==17){
                imgsrc = futu18;
            }else if(i==18){
                imgsrc = futu19;
            }else if(i==19){
                imgsrc = futu20;
            }
            //
            let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
            let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
            let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
            let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
            //
            let _skuId = _shangjia_variants_skus[i]['subsku'];
            _skuId = 'S'+_skuId;
            let export_data_item = {
                'Handle': _Handle,
                'Title': i==0?shangjia_about_contact_and_basic_info['_shangjia_goodsName']:'',
                'Body (HTML)': i==0?_body_html:'',
                'Vendor': i==0?'mysite':'',
                'Type':'',
                'Tags':'',
                'Published':i==0?'TRUE':'',
                'Option1 Name': specs_key1_name,
                'Option1 Value': _shangjia_variants_skus[i]['specs_key1_value'],
                'Option2 Name': specs_key2_name,
                'Option2 Value': _shangjia_variants_skus[i]['specs_key2_value'],
                'Option3 Name': specs_key3_name,
                'Option3 Value': _shangjia_variants_skus[i]['specs_key3_value'],
                'Variant SKU': _skuId,
                'Variant Grams': 0,
                'Variant Inventory Tracker':'shopify',
                'Variant Inventory Qty': _shangjia_variants_skus[i]['stockQuantity'],
                'Variant Inventory Policy':'continue',
                'Variant Fulfillment Service':'manual',
                'Variant Price':_shangjia_variants_skus[i]['normalPriceStr'].replace('$',''),
                'Variant Compare At Price':_shangjia_variants_skus[i]['normalPriceStr'].replace('$',''),
                'Variant Requires Shipping':'TRUE',
                'Variant Taxable':'TRUE',
                'Variant Barcode':'',
                'Image Src': imgsrc,
                'Image Position': imgsrc?(i+1):'',
                'Image Alt Text':'',
                'Gift Card': i==0?'FALSE':'',
                'SEO Title': i==0?shangjia_about_contact_and_basic_info['_shangjia_goodsName']:'',
                'SEO Description': i==0?shangjia_about_contact_and_basic_info['_shangjia_goodsName']:'',
                'Google Shopping / Google Product Category':'',
                'Google Shopping / Gender':'',
                'Google Shopping / Age Group':'',
                'Google Shopping / MPN':'',
                'Google Shopping / AdWords Grouping':'',
                'Google Shopping / AdWords Labels':'',
                'Google Shopping / Condition':'',
                'Google Shopping / Custom Product':'',
                'Google Shopping / Custom Label 0':'',
                'Google Shopping / Custom Label 1':'',
                'Google Shopping / Custom Label 2':'',
                'Google Shopping / Custom Label 3':'',
                'Google Shopping / Custom Label 4':'',
                'Variant Image': _shangjia_variants_skus[i]['img'],
                'Variant Weight Unit':'',
                'Variant Tax Code':'',
                'Cost per item':'',
                'Status':i==0?'active':''
            }
            export_datas.push(export_data_item);
            //
        }
        //
        if(_shangjia_gallery_arr.length > _shangjia_variants_skus.length){
            //
            for(let _g=_shangjia_variants_skus.length;_g<_shangjia_gallery_arr.length;_g++){
                let export_data_item = {
                    'Handle': _Handle,
                    'Title': '',
                    'Body (HTML)': '',
                    'Vendor': '',
                    'Type':'',
                    'Tags':'',
                    'Published':'',
                    'Option1 Name': '',
                    'Option1 Value': '',
                    'Option2 Name': '',
                    'Option2 Value': '',
                    'Option3 Name': '',
                    'Option3 Value': '',
                    'Variant SKU': '',
                    'Variant Grams': '',
                    'Variant Inventory Tracker':'',
                    'Variant Inventory Qty': '',
                    'Variant Inventory Policy':'',
                    'Variant Fulfillment Service':'',
                    'Variant Price':'',
                    'Variant Compare At Price':'',
                    'Variant Requires Shipping':'',
                    'Variant Taxable':'',
                    'Variant Barcode':'',
                    'Image Src': _shangjia_gallery_arr[_g],
                    'Image Position': (_g+1),
                    'Image Alt Text':'',
                    'Gift Card': '',
                    'SEO Title': '',
                    'SEO Description': '',
                    'Google Shopping / Google Product Category':'',
                    'Google Shopping / Gender':'',
                    'Google Shopping / Age Group':'',
                    'Google Shopping / MPN':'',
                    'Google Shopping / AdWords Grouping':'',
                    'Google Shopping / AdWords Labels':'',
                    'Google Shopping / Condition':'',
                    'Google Shopping / Custom Product':'',
                    'Google Shopping / Custom Label 0':'',
                    'Google Shopping / Custom Label 1':'',
                    'Google Shopping / Custom Label 2':'',
                    'Google Shopping / Custom Label 3':'',
                    'Google Shopping / Custom Label 4':'',
                    'Variant Image': '',
                    'Variant Weight Unit':'',
                    'Variant Tax Code':'',
                    'Cost per item':'',
                    'Status':''
                }
                export_datas.push(export_data_item);
            }
        }
        exportToCsv(export_datas, 'gycharm-1688-shopify-export-'+_shangjia_goodsId, "Sheet1");
    }
}

function export_tiktok_xlsx_output(need_item){
    let export_datas = [];
    let shangjia_about_contact_and_basic_info = need_item;
    let _shangjia_goodsId = shangjia_about_contact_and_basic_info['_shangjia_goodsId']
    //
    let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
    //
    let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

    let futu1 = '';
    let futu2 = '';
    let futu3 = '';
    let futu4 = '';
    let futu5 = '';

    let futu6 = '';
    let futu7 = '';
    let futu8 = '';
    let futu9 = '';
    let futu10 = '';

    let futu11 = '';
    let futu12 = '';
    let futu13 = '';
    let futu14 = '';
    let futu15 = '';

    let futu16 = '';
    let futu17 = '';
    let futu18 = '';
    let futu19 = '';
    let futu20 = '';

    if(_shangjia_gallery_arr.length>=1){
        futu1 = _shangjia_gallery_arr[0];
    }
    if(_shangjia_gallery_arr.length>=2){
        futu2 = _shangjia_gallery_arr[1];
    }
    if(_shangjia_gallery_arr.length>=3){
        futu3 = _shangjia_gallery_arr[2];
    }
    if(_shangjia_gallery_arr.length>=4){
        futu4 = _shangjia_gallery_arr[3];
    }
    if(_shangjia_gallery_arr.length>=5){
        futu5 = _shangjia_gallery_arr[4];
    }
    if(_shangjia_gallery_arr.length>=6){
        futu6 = _shangjia_gallery_arr[5];
    }
    if(_shangjia_gallery_arr.length>=7){
        futu7 = _shangjia_gallery_arr[6];
    }
    if(_shangjia_gallery_arr.length>=8){
        futu8 = _shangjia_gallery_arr[7];
    }
    if(_shangjia_gallery_arr.length>=9){
        futu9 = _shangjia_gallery_arr[8];
    }
    if(_shangjia_gallery_arr.length>=10){
        futu10 = _shangjia_gallery_arr[9];
    }
    if(_shangjia_gallery_arr.length>=11){
        futu11 = _shangjia_gallery_arr[10];
    }
    if(_shangjia_gallery_arr.length>=12){
        futu12 = _shangjia_gallery_arr[11];
    }
    if(_shangjia_gallery_arr.length>=13){
        futu13 = _shangjia_gallery_arr[12];
    }
    if(_shangjia_gallery_arr.length>=14){
        futu14 = _shangjia_gallery_arr[13];
    }
    if(_shangjia_gallery_arr.length>=15){
        futu15 = _shangjia_gallery_arr[14];
    }
    if(_shangjia_gallery_arr.length>=16){
        futu16 = _shangjia_gallery_arr[15];
    }
    if(_shangjia_gallery_arr.length>=17){
        futu17 = _shangjia_gallery_arr[16];
    }
    if(_shangjia_gallery_arr.length>=18){
        futu18 = _shangjia_gallery_arr[17];
    }
    if(_shangjia_gallery_arr.length>=19){
        futu19 = _shangjia_gallery_arr[18];
    }
    if(_shangjia_gallery_arr.length>=20){
        futu20 = _shangjia_gallery_arr[19];
    }
    //
    let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
    //
    for(let i=0;i<_shangjia_variants_skus.length;i++){
        //
        let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
        let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
        let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
        let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
        //
        let _skuId = _shangjia_variants_skus[i]['subsku'];
        _skuId = 'T'+_skuId;
        //
        let _category_str = '';

        let export_data_item = {
            'Category': _category_str,
            'Brand':'',
            'Product Name': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
            'Product Description': shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'],
            'Package Weight(lb)':'',
            'Package Length(inch)':'',
            'Package Width(inch)':'',
            'Package Height(inch)':'',
            'Delivery options':'Default',
            'Identifier Code Type':'',
            'Identifier Code':'',
            '属性1名': specs_key1_name,
            'Variation 1': _shangjia_variants_skus[i]['specs_key1_value'],
            '属性2名': specs_key2_name,
            'Variation 2': _shangjia_variants_skus[i]['specs_key2_value'],
            '属性3名': specs_key3_name,
            'Variation 3': _shangjia_variants_skus[i]['specs_key3_value'],
            '属性4名': specs_key4_name,
            'Variation 4': _shangjia_variants_skus[i]['specs_key4_value'],
            'Variant Image': _shangjia_variants_skus[i]['img'],
            'Retail Price (Local Currency)': _shangjia_variants_skus[i]['normalPriceStr'],
            'Quantity in RUIZ SPORT STORE': _shangjia_variants_skus[i]['stockQuantity'],
            'Seller SKU': _skuId,
            'Main Product Image': _shangjia_variants_skus[i]['img'],
            'Product Image 2': futu1,
            'Product Image 3': futu2,
            'Product Image 4': futu3,
            'Product Image 5': futu4,
            'Product Image 6': futu5,
            'Product Image 7': futu6,
            'Product Image 8': futu7,
            'Product Image 9': futu8,
            'Product Image 10': futu9,
            'Product Image 11': futu10,
            'Product Image 12': futu11,
            'Product Image 13': futu12,
            'Product Image 14': futu13,
            'Product Image 15': futu14,
            'Product Image 16': futu15,
            'Product Image 17': futu16,
            'Product Image 18': futu17,
            'Product Image 19': futu18,
            'Product Image 20': futu19,
            'Product Image 21': futu20,
            'Size Chart':'',
            'Product Status':'',
        }
        export_datas.push(export_data_item);
        //
    }
    //
    exportToExcel(export_datas, 'gycharm-1688-tiktok-export-'+Date.now(), "Sheet1");
    //
}

function export_single(pingtai='shopify') {
    //
    let shangjia_info = {};
    let _shangjia_product_link = '';
    let _shangjia_a_link = window.location.href;
    if(_shangjia_a_link.indexOf('?')!=-1){
        let _shangjia_a_link_arr = _shangjia_a_link.split('?');
        _shangjia_product_link = _shangjia_a_link_arr[0];
    }else{
        _shangjia_product_link = _shangjia_a_link;
    }
    let _shangjia_goodsId = _shangjia_product_link.replace('https://detail.1688.com/offer/','')
        .replace('.html','');

    let _shangjia_goodsName = $('.od-pc-offer-title-contain .title-first-column .title-text').text();
    if(_shangjia_goodsName){
        let runParamscript = util_getscript_pageData_content($('html').html());
        console.log('runParamscript a1');
        if (runParamscript) {
            runParamscript = runParamscript.trim();
            let runParamscriptArr = runParamscript.split('window.__INIT_DATA=');
            runParamscript = runParamscriptArr[1];
            runParamscript = runParamscript.trim();
            //
            //console.log('runParamscript');
            //console.log(runParamscript);
            let runParamscript_json = JSON.parse(runParamscript);
            console.log('runParamscript_json');
            console.log(runParamscript_json);
            //
            if (runParamscript_json) {
                //
                let shangjia_info = {};
                shangjia_info['_shangjia_product_link'] = _shangjia_product_link;
                shangjia_info['_shangjia_goodsId'] = 'S'+runParamscript_json['globalData']['tempModel']['offerId'];
                //
                _shangjia_goodsName = _shangjia_goodsName.trim();
                shangjia_info['_shangjia_goodsName'] = _shangjia_goodsName;
                //
                let _shangjia_minOnSalePriceStr = $('.price-wrapper .price-box:eq(0) .price-text').text();
                if(_shangjia_minOnSalePriceStr =='' || typeof _shangjia_minOnSalePriceStr == 'undefined'){
                    _shangjia_minOnSalePriceStr = $('.step-price-wrapper .step-price-item:eq(0) .price-text').text();
                }
                _shangjia_minOnSalePriceStr = _shangjia_minOnSalePriceStr.replace('¥','');
                _shangjia_minOnSalePriceStr = _shangjia_minOnSalePriceStr.trim();
                shangjia_info['_shangjia_minOnSalePriceStr'] = _shangjia_minOnSalePriceStr;
                //
                shangjia_info['_shangjia_minOriginPriceStr'] = _shangjia_minOnSalePriceStr;
                //
                let _shangjia_goodsProperty = "<div class='od-pc-offer-cross'>"+$('.od-pc-offer-cross').html()+"</div>"+
                            "<div class='od-pc-attribute'>"+$('.od-pc-attribute').html()+"</div>";
                shangjia_info['_shangjia_goodsProperty'] = _shangjia_goodsProperty;
                shangjia_info['_shangjia_desc'] = "<div class='content-detail'>"+$('.content-detail').html()+"</div>";
                //
                let _shangjia_gallery = [];
                $('.img-list-wrapper .detail-gallery-turn-wrapper').each(function (){
                    let _img = $(this).find('img.detail-gallery-img').attr('src');
                    _shangjia_gallery.push(_img);
                });
                shangjia_info['_shangjia_gallery'] = _shangjia_gallery;
                let _shangjia_hdThumbUrl = _shangjia_gallery[0];
                shangjia_info['_shangjia_hdThumbUrl'] = _shangjia_hdThumbUrl;
                //
                let _shangjia_productDetailFlatList = [];
                $('.od-pc-detail-description img').each(function (){
                    let _img = $(this).attr('data-lazyload-src');
                    _shangjia_productDetailFlatList.push(_img);
                });
                shangjia_info['_shangjia_productDetailFlatList'] = _shangjia_productDetailFlatList;
                //
                //子sku
                let specs_key1_name = '';
                let specs_key2_name = '';
                let color_arr = [];
                let size_arr = [];
                //
                let skuProps = [];
                //
                let skuModel = runParamscript_json['globalData']['skuModel'];
                if(skuModel.hasOwnProperty('skuProps')){
                    skuProps = runParamscript_json['globalData']['skuModel']['skuProps'];
                    if(skuProps.length >=2){
                        specs_key1_name = skuProps[0]['prop'];
                        specs_key2_name = skuProps[1]['prop'];

                        color_arr = skuProps[0]['value'];
                        size_arr = skuProps[1]['value'];
                    }else if(skuProps.length == 1){
                        let specs_key_name = skuProps[0]['prop'];
                        if(specs_key_name.indexOf('颜色')!=-1){
                            specs_key1_name = specs_key_name;
                            color_arr = skuProps[0]['value'];
                        }else{
                            specs_key2_name = specs_key_name;
                            size_arr = skuProps[0]['value'];
                        }
                    }
                }

                //
                let skuInfoMapOriginal = runParamscript_json['globalData']['skuModel']['skuInfoMap'];
                //
                let _shangjia_variants_skus = [];
                if(skuProps.length >=2){ //颜色及尺寸
                    for(let _color_key in color_arr){
                        //
                        for(let _size_key in size_arr){
                            //
                            let _subsku = color_arr[_color_key]['name']+'&gt;'+size_arr[_size_key]['name'];
                            if(skuInfoMapOriginal.hasOwnProperty(_subsku)){
                                //
                                let normalPriceStr = skuInfoMapOriginal[_subsku]['discountPrice'];
                                let normalLinePriceStr = skuInfoMapOriginal[_subsku]['price'];
                                if(normalPriceStr == '' || typeof normalPriceStr == 'undefined'){
                                    normalPriceStr = runParamscript_json['globalData']['skuModel']['skuPriceScale'];
                                }
                                let _stockQuantity = skuInfoMapOriginal[_subsku]['canBookCount'];
                                let _img = color_arr[_color_key]['imageUrl'];
                                let _specs_key1_value = color_arr[_color_key]['name'];
                                let specs_key2_value = size_arr[_size_key]['name'];
                                //
                                let subsku = shangjia_info['_shangjia_goodsId']+_subsku.replace("&gt;",'-');
                                _shangjia_variants_skus.push({
                                    'subsku': subsku, //自定义变体带属性SKU
                                    'normalPriceStr': normalPriceStr, //特价
                                    'normalLinePriceStr': normalLinePriceStr, //原价
                                    'img':_img,
                                    'specs_key1_name':specs_key1_name,
                                    'specs_key1_value':_specs_key1_value,
                                    'specs_key2_name':specs_key2_name,
                                    'specs_key2_value':specs_key2_value,
                                    'specs_key3_name':'',
                                    'specs_key3_value':'',
                                    'specs_key4_name':'',
                                    'specs_key4_value':'',
                                    'stockQuantity': _stockQuantity,
                                    'skuId': '' //原变体sku
                                });
                                //
                            }

                        }
                        //
                    }
                }else if(skuProps.length == 1){
                    //
                    if(specs_key1_name){ //颜色
                        for(let _color_key in color_arr){
                            //
                            let _subsku = color_arr[_color_key]['name'];
                            if(skuInfoMapOriginal.hasOwnProperty(_subsku)){
                                //
                                let normalPriceStr = skuInfoMapOriginal[_subsku]['discountPrice'];
                                let normalLinePriceStr = skuInfoMapOriginal[_subsku]['price'];

                                if(normalPriceStr == '' || typeof normalPriceStr == 'undefined'){
                                    normalPriceStr = runParamscript_json['globalData']['skuModel']['skuPriceScale'];
                                }
                                let _stockQuantity = skuInfoMapOriginal[_subsku]['canBookCount'];
                                let _img = color_arr[_color_key]['imageUrl'];
                                let _specs_key1_value = color_arr[_color_key]['name'];
                                //
                                let subsku = shangjia_info['_shangjia_goodsId']+_subsku;
                                _shangjia_variants_skus.push({
                                    'subsku': subsku, //自定义变体带属性SKU
                                    'normalPriceStr': normalPriceStr, //特价
                                    'normalLinePriceStr': normalLinePriceStr, //原价
                                    'img':_img,
                                    'specs_key1_name':specs_key1_name,
                                    'specs_key1_value':_specs_key1_value,
                                    'specs_key2_name':specs_key2_name,
                                    'specs_key2_value':'',
                                    'specs_key3_name':'',
                                    'specs_key3_value':'',
                                    'specs_key4_name':'',
                                    'specs_key4_value':'',
                                    'stockQuantity': _stockQuantity,
                                    'skuId': '' //原变体sku
                                });
                                //
                            }
                            //
                        }
                    }else if(specs_key2_name){ //尺寸
                        //
                        for(let _size_key in size_arr){
                            //
                            let _subsku = size_arr[_size_key]['name'];
                            if(skuInfoMapOriginal.hasOwnProperty(_subsku)){
                                //
                                let normalPriceStr = skuInfoMapOriginal[_subsku]['discountPrice'];
                                let normalLinePriceStr = skuInfoMapOriginal[_subsku]['price'];
                                if(normalPriceStr == '' || typeof normalPriceStr == 'undefined'){
                                    normalPriceStr = runParamscript_json['globalData']['skuModel']['skuPriceScale'];
                                }
                                let _stockQuantity = skuInfoMapOriginal[_subsku]['canBookCount'];
                                //
                                let _size_item = size_arr[_size_key];
                                let _img = '';
                                if(_size_item.hasOwnProperty('imageUrl')){
                                    _img = size_arr[_size_key]['imageUrl'];
                                }
                                //
                                let specs_key2_value = size_arr[_size_key]['name'];
                                //
                                _shangjia_variants_skus.push({
                                    'subsku': shangjia_info['_shangjia_goodsId']+_subsku, //自定义变体带属性SKU
                                    'normalPriceStr': normalPriceStr, //特价
                                    'normalLinePriceStr': normalLinePriceStr, //原价
                                    'img':_img,
                                    'specs_key1_name':specs_key1_name,
                                    'specs_key1_value':'',
                                    'specs_key2_name':specs_key2_name,
                                    'specs_key2_value':specs_key2_value,
                                    'specs_key3_name':'',
                                    'specs_key3_value':'',
                                    'specs_key4_name':'',
                                    'specs_key4_value':'',
                                    'stockQuantity': _stockQuantity,
                                    'skuId': '' //原变体sku
                                });
                                //
                            }
                            //
                        }
                        //
                    }
                    //
                }else{ //无属性
                    //
                    _shangjia_variants_skus.push({
                        'subsku': '', //自定义变体带属性SKU
                        'normalPriceStr': shangjia_info['_shangjia_minOnSalePriceStr'], //特价
                        'normalLinePriceStr': shangjia_info['_shangjia_minOriginPriceStr'], //原价
                        'img':'',
                        'specs_key1_name':'',
                        'specs_key1_value':'',
                        'specs_key2_name':'',
                        'specs_key2_value':'',
                        'specs_key3_name':'',
                        'specs_key3_value':'',
                        'specs_key4_name':'',
                        'specs_key4_value':'',
                        'stockQuantity': '',
                        'skuId': '' //原变体sku
                    });
                    //
                }
                shangjia_info['_shangjia_variants_skus'] = _shangjia_variants_skus;
                //
                shangjia_info['_shangjia_sold'] = $('.title-sale-column .title-info-number').text();
                let _shangjia_reivew_num_str = $(".title-evaluate-info .title-info-number").text();
                shangjia_info['_shangjia_reivew_num'] = _shangjia_reivew_num_str;
                let _shangjia_VideoUrl = $('video').attr('src');
                shangjia_info['_shangjia_VideoUrl'] = _shangjia_VideoUrl;

                console.log('shangjia_info11');
                console.log(shangjia_info);
                //
                if(pingtai == 'shopify'){
                    export_shopify_csv_output(shangjia_info);
                }else if(pingtai == 'tiktok'){
                    export_tiktok_xlsx_output(shangjia_info);
                }else if(pingtai = 'normal'){
                    export_normal_xlsx_output(shangjia_info);
                }
                //
            }
        }
        //
    }
}
//
function add_export_pingtai_btn(){
    let current_url = window.location.href;
    // 创建一个按钮元素
    if(current_url.indexOf('detail.1688.com/offer')!=-1){
         var newNormalButton = $("<button>", {
            text: '通用Excel格式导出', // 按钮文本
            style: "display: block;\n" +
                "    position: absolute;\n" +
                "    top: 10px;\n" +
                "    right:350px;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    cursor:pointer;\n" +
                "    border-radius: 22px;",
            click: function() {
               export_single('normal');
            } // 点击按钮时执行的函数
         });
         $('.od-pc-layout-detail-tab-container .layout-right').append(newNormalButton);
         //
         var newButton = $("<button>", {
            text: '导出Shopify格式', // 按钮文本
            style: "display: block;\n" +
                "    position: absolute;\n" +
                "    top: 60px;\n" +
                "    right:350px;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    cursor:pointer;\n" +
                "    border-radius: 22px;",
            click: function() {
               export_single('shopify');
            } // 点击按钮时执行的函数
        });
        // 将按钮添加到指定的<div>中
        $('.od-pc-layout-detail-tab-container .layout-right').append(newButton);
        //
        var newTiktokButton = $("<button>", {
            text: '导出Tiktok格式', // 按钮文本
            style: "display: block;\n" +
                "    position: absolute;\n" +
                "    top: 110px;\n" +
                "    right:350px;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    cursor:pointer;\n" +
                "    border-radius: 22px;",
            click: function() {
               export_single('tiktok');
            } // 点击按钮时执行的函数
        });
        // 将按钮添加到指定的<div>中
        $('.od-pc-layout-detail-tab-container .layout-right').append(newTiktokButton);
    }
}

$(document).ready(function () {
    //
     let current_url = window.location.href;
     if(current_url) {
         //找货源selloffer/offer_search
         if (current_url.indexOf('selloffer/offer_search') != -1
             || current_url.indexOf('selloffer/imall_search') != -1) {
            //
             setTimeout(function () {
                    shangjia_search_huoyuan_caiji();
                }, 2000);
             //
         }
     }
     //
     add_export_pingtai_btn();
     setTimeout(function() {
        shangjia_new_tab_process_item_step2();
     }, 2000);
    //
});

function util_scrollToBottom(iframe, callback) {
    var iframeWindow = iframe.contentWindow;
    var start = iframeWindow.pageYOffset; // 当前滚动位置
    var end = iframeWindow.document.body.scrollHeight - iframeWindow.innerHeight; // 滚动到底部

    var duration = 8000; // 3 秒
    var startTime = null;

    function scroll(time) {
        if (!startTime) {
            startTime = time;
        }
        var progress = (time - startTime) / duration;
        if (progress > 1) {
            progress = 1;
        }
        var newPosition = start + (end - start) * progress;
        iframeWindow.scrollTo(0, newPosition);

        if (progress < 1) {
            requestAnimationFrame(scroll);
        } else {
            // 滚动完成后执行回调
            callback();
        }
    }
    requestAnimationFrame(scroll);
}

function util_currentpage_scrollToBottomWithCallback(callback) {
    var start = window.pageYOffset; // 当前滚动位置
    var end = document.documentElement.scrollHeight - window.innerHeight; // 滚动到底部

    var duration = 8000; // 8 秒
    var startTime = null;

    function scroll(time) {
        if (!startTime) {
            startTime = time;
        }
        var progress = (time - startTime) / duration;
        if (progress > 1) {
            progress = 1;
        }
        var newPosition = start + (end - start) * progress;
        window.scrollTo(0, newPosition);

        if (progress < 1) {
            requestAnimationFrame(scroll);
        } else {
            // 滚动完成后执行回调
            callback();
        }
    }
    requestAnimationFrame(scroll);
}

function shangjia_new_tab_process_item(need_item){
    console.log('shangjia_new_tab_process_item a1');
    //$('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;'>正在采集，30秒采集一个。如果长时间未动，可以尝试刷新该页面！如遇到验证码请及时验证。</div>");
    //
    // 在新标签页中打开指定的 URL
    var message = {
        action: 'open_new_tab',
        info: '',
        need_item: need_item
    };
    send_message_to_popup(message);
    //
}

function shangjia_get_subskus(_html='',_shangjia_goodsId='',
                              specs_key1_name='',
                              _specs_key1_value = '',
                              specs_key2_name='',
                              _shangjia_minOriginPriceStr=0,
                              _img=''){
    let _dom = $(_html);
    //
    let _shangjia_variants_skus_cucao = [];
    _dom.find('.sku-item-wrapper').each(function (){
        //
        let specs_key2_value = $(this).find('.sku-item-name').text();
        //
        let _subsku = _shangjia_goodsId+_specs_key1_value+'-'+specs_key2_value;

        let _sku_price = $(this).find('.discountPrice-price').text();
        _sku_price = _sku_price.replace('元','');
        _sku_price = _sku_price.trim();

        let _stockQuantity = $(this).find('.sku-item-sale-num').text();
        _stockQuantity = _stockQuantity.replace('个','').replace('可售','');
        _stockQuantity = _stockQuantity.trim();

        _shangjia_variants_skus_cucao.push({
            'subsku': _subsku, //自定义变体带属性SKU
            'normalPriceStr': _sku_price, //特价
            'normalLinePriceStr': '', //原价
            'img':_img,
            'specs_key1_name':specs_key1_name,
            'specs_key1_value':_specs_key1_value,
            'specs_key2_name':specs_key2_name,
            'specs_key2_value':specs_key2_value,
            'specs_key3_name':'',
            'specs_key3_value':'',
            'specs_key4_name':'',
            'specs_key4_value':'',
            'stockQuantity': _stockQuantity,
            'skuId': '' //原变体sku
        });
    });
    //console.log('_shangjia_variants_skus_cucao');
    //console.log(_shangjia_variants_skus_cucao);
    return _shangjia_variants_skus_cucao;
    //
}

function util_getscript_pageData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('window.__GLOBAL_DADA=') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function shangjia_getsubsku_img(skuPropValues=[], skuprop=''){
    let _img = '';
    for(let i=0;i<skuPropValues.length;i++){
        if(skuPropValues[i]['name'] == skuprop){
            _img = skuPropValues[i]['imageUrl'];
            break;
        }
    }
    return _img;
}

function shangjia_new_tab_process_item_step2(){
    let currentUrl = window.location.href;
    if(currentUrl.indexOf('_shangjia_about_contact_and_basic_info_link_key') != -1) {
        let queryParams = util_getCurrentUrlQueryStringParams();
        console.log('queryParams');
        console.log(queryParams);
        let _shangjia_about_contact_and_basic_info_link_key = queryParams['_shangjia_about_contact_and_basic_info_link_key'];
        let _request_type = queryParams['_request_type'];
        //
        /**
         *
         //
         '_shangjia_goodsId':'', //sku
         '_shangjia_variants_skus': [], //数组
         '_shangjia_goodsName': '',
         '_shangjia_goodsProperty':'',//description,deschtml
         '_shangjia_minOnSalePriceStr':'', //最小价格,当没有属性时选择该价格
         '_shangjia_hdThumbUrl': '',//主图
         '_shangjia_gallery':[], //图片列表
         '_shangjia_productDetailFlatList':[],//details imgs
         '_shangjia_category':'',//brumb
         '_shangjia_VideoUrl':'', //video
         //
         _shangjia_variants_skus
         {
             'subsku': _skus[_i]['goodsId']+subsku_specs, //自定义变体带属性SKU
             'normalPriceStr': _skus[_i]['normalPriceStr'], //特价
             'normalLinePriceStr': _skus[_i]['normalLinePriceStr'], //原价
             'img':_skus[_i]['specShowImageUrl'],
             'specs_key1_name':specs_key1_name,
             'specs_key1_value':specs_key1_value,
             'specs_key2_name':specs_key2_name,
             'specs_key2_value':specs_key2_value,
             'specs_key3_name':specs_key3_name,
             'specs_key3_value':specs_key3_value,
             'specs_key4_name':specs_key4_name,
             'specs_key4_value':specs_key4_value,
             'stockQuantity': _skus[_i]['stockQuantity'],
             'skuId': _skus[_i]['skuId'] //原变体sku
             }
         */
        let _shangjia_goodsName = $('.od-pc-offer-title-contain .title-first-column .title-text').text();
        if(_shangjia_goodsName){
            let runParamscript = util_getscript_pageData_content($('html').html());
            console.log('runParamscript a1');
            if (runParamscript) {
                runParamscript = runParamscript.trim();
                let runParamscriptArr = runParamscript.split('window.__INIT_DATA=');
                runParamscript = runParamscriptArr[1];
                runParamscript = runParamscript.trim();
                //
                //console.log('runParamscript');
                //console.log(runParamscript);
                let runParamscript_json = JSON.parse(runParamscript);
                console.log(runParamscript_json);
                //
                if (runParamscript_json) {
                    //
                    let shangjia_info = {};
                    shangjia_info['_shangjia_goodsId'] = 'S'+runParamscript_json['globalData']['tempModel']['offerId'];
                    //
                     _shangjia_goodsName = _shangjia_goodsName.trim();
                     shangjia_info['_shangjia_goodsName'] = _shangjia_goodsName;
                    //
                    let _shangjia_minOnSalePriceStr = $('.price-wrapper .price-box:eq(0) .price-text').text();
                    if(_shangjia_minOnSalePriceStr =='' || typeof _shangjia_minOnSalePriceStr == 'undefined'){
                        _shangjia_minOnSalePriceStr = $('.step-price-wrapper .step-price-item:eq(0) .price-text').text();
                    }
                    _shangjia_minOnSalePriceStr = _shangjia_minOnSalePriceStr.replace('¥','');
                    _shangjia_minOnSalePriceStr = _shangjia_minOnSalePriceStr.trim();
                    shangjia_info['_shangjia_minOnSalePriceStr'] = _shangjia_minOnSalePriceStr;
                    //
                    shangjia_info['_shangjia_minOriginPriceStr'] = _shangjia_minOnSalePriceStr;
                    //
                    let _shangjia_goodsProperty = "<div class='od-pc-offer-cross'>"+$('.od-pc-offer-cross').html()+"</div>"+
                            "<div class='od-pc-attribute'>"+$('.od-pc-attribute').html()+"</div>";
                    shangjia_info['_shangjia_goodsProperty'] = _shangjia_goodsProperty;
                    //
                    let _shangjia_gallery = [];
                     $('.img-list-wrapper .detail-gallery-turn-wrapper').each(function (){
                         let _img = $(this).find('img.detail-gallery-img').attr('src');
                         _shangjia_gallery.push(_img);
                     });
                     shangjia_info['_shangjia_gallery'] = _shangjia_gallery;
                     let _shangjia_hdThumbUrl = _shangjia_gallery[0];
                     shangjia_info['_shangjia_hdThumbUrl'] = _shangjia_hdThumbUrl;
                     //
                     let _shangjia_productDetailFlatList = [];
                     $('.od-pc-detail-description img').each(function (){
                         let _img = $(this).attr('data-lazyload-src');
                         _shangjia_productDetailFlatList.push(_img);
                     });
                     shangjia_info['_shangjia_productDetailFlatList'] = _shangjia_productDetailFlatList;
                    //
                    let _shangjia_desc = '';
                    for(let _i=0;_i<_shangjia_productDetailFlatList.length;_i++){
                        _shangjia_desc+="<img src='"+_shangjia_productDetailFlatList[_i]+"'/>";
                    }
                    shangjia_info['_shangjia_desc'] = "<div class='content-detail'>"+_shangjia_desc+"</div>";

                    //子sku
                    let specs_key1_name = '';
                    let specs_key2_name = '';
                    let color_arr = [];
                    let size_arr = [];
                    let skuProps = [];
                    //
                    let skuModel = runParamscript_json['globalData']['skuModel'];
                    if(skuModel.hasOwnProperty('skuProps')){
                        skuProps = runParamscript_json['globalData']['skuModel']['skuProps'];
                        if(skuProps.length >=2){
                            specs_key1_name = skuProps[0]['prop'];
                            specs_key2_name = skuProps[1]['prop'];

                            color_arr = skuProps[0]['value'];
                            size_arr = skuProps[1]['value'];
                        }else if(skuProps.length == 1){
                            let specs_key_name = skuProps[0]['prop'];
                            if(specs_key_name.indexOf('颜色')!=-1){
                                specs_key1_name = specs_key_name;
                                color_arr = skuProps[0]['value'];
                            }else{
                                specs_key2_name = specs_key_name;
                                size_arr = skuProps[0]['value'];
                            }
                        }
                    }

                    //
                    let skuInfoMapOriginal = runParamscript_json['globalData']['skuModel']['skuInfoMap'];
                    //
                    let _shangjia_variants_skus = [];
                    if(skuProps.length >=2){ //颜色及尺寸
                        for(let _color_key in color_arr){
                            //
                            for(let _size_key in size_arr){
                                //
                                let _subsku = color_arr[_color_key]['name']+'&gt;'+size_arr[_size_key]['name'];
                                if(skuInfoMapOriginal.hasOwnProperty(_subsku)){
                                    //
                                    let normalPriceStr = skuInfoMapOriginal[_subsku]['discountPrice'];
                                    let normalLinePriceStr = skuInfoMapOriginal[_subsku]['price'];
                                    if(normalPriceStr == '' || typeof normalPriceStr == 'undefined'){
                                        normalPriceStr = runParamscript_json['globalData']['skuModel']['skuPriceScale'];
                                    }
                                    let _stockQuantity = skuInfoMapOriginal[_subsku]['canBookCount'];
                                    let _img = color_arr[_color_key]['imageUrl'];
                                    let _specs_key1_value = color_arr[_color_key]['name'];
                                    let specs_key2_value = size_arr[_size_key]['name'];
                                    //
                                    let subsku = shangjia_info['_shangjia_goodsId']+_subsku.replace("&gt;",'-');
                                    _shangjia_variants_skus.push({
                                        'subsku': subsku, //自定义变体带属性SKU
                                        'normalPriceStr': normalPriceStr, //特价
                                        'normalLinePriceStr': normalLinePriceStr, //原价
                                        'img':_img,
                                        'specs_key1_name':specs_key1_name,
                                        'specs_key1_value':_specs_key1_value,
                                        'specs_key2_name':specs_key2_name,
                                        'specs_key2_value':specs_key2_value,
                                        'specs_key3_name':'',
                                        'specs_key3_value':'',
                                        'specs_key4_name':'',
                                        'specs_key4_value':'',
                                        'stockQuantity': _stockQuantity,
                                        'skuId': '' //原变体sku
                                    });
                                    //
                                }

                            }
                            //
                        }
                    }else if(skuProps.length == 1){
                        //
                        if(specs_key1_name){ //颜色
                            for(let _color_key in color_arr){
                                //
                                let _subsku = color_arr[_color_key]['name'];
                                if(skuInfoMapOriginal.hasOwnProperty(_subsku)){
                                    //
                                    let normalPriceStr = skuInfoMapOriginal[_subsku]['discountPrice'];
                                    let normalLinePriceStr = skuInfoMapOriginal[_subsku]['price'];
                                    if(normalPriceStr == '' || typeof normalPriceStr == 'undefined'){
                                        normalPriceStr = runParamscript_json['globalData']['skuModel']['skuPriceScale'];
                                    }
                                    let _stockQuantity = skuInfoMapOriginal[_subsku]['canBookCount'];
                                    let _img = color_arr[_color_key]['imageUrl'];
                                    let _specs_key1_value = color_arr[_color_key]['name'];
                                    //
                                    _shangjia_variants_skus.push({
                                        'subsku': shangjia_info['_shangjia_goodsId']+_subsku, //自定义变体带属性SKU
                                        'normalPriceStr': normalPriceStr, //特价
                                        'normalLinePriceStr': normalLinePriceStr, //原价
                                        'img':_img,
                                        'specs_key1_name':specs_key1_name,
                                        'specs_key1_value':_specs_key1_value,
                                        'specs_key2_name':specs_key2_name,
                                        'specs_key2_value':'',
                                        'specs_key3_name':'',
                                        'specs_key3_value':'',
                                        'specs_key4_name':'',
                                        'specs_key4_value':'',
                                        'stockQuantity': _stockQuantity,
                                        'skuId': '' //原变体sku
                                    });
                                    //
                                }
                                //
                            }
                        }else if(specs_key2_name){ //尺寸
                            //
                            for(let _size_key in size_arr){
                                //
                                let _subsku = size_arr[_size_key]['name'];
                                if(skuInfoMapOriginal.hasOwnProperty(_subsku)){
                                    //
                                    let normalPriceStr = skuInfoMapOriginal[_subsku]['discountPrice'];
                                    let normalLinePriceStr = skuInfoMapOriginal[_subsku]['price'];
                                    if(normalPriceStr == '' || typeof normalPriceStr == 'undefined'){
                                        normalPriceStr = runParamscript_json['globalData']['skuModel']['skuPriceScale'];
                                    }
                                    let _stockQuantity = skuInfoMapOriginal[_subsku]['canBookCount'];
                                    //
                                    let _size_item = size_arr[_size_key];
                                    let _img = '';
                                    if(_size_item.hasOwnProperty('imageUrl')){
                                        _img = size_arr[_size_key]['imageUrl'];
                                    }
                                    //
                                    let specs_key2_value = size_arr[_size_key]['name'];
                                    //
                                    _shangjia_variants_skus.push({
                                        'subsku': shangjia_info['_shangjia_goodsId']+_subsku, //自定义变体带属性SKU
                                        'normalPriceStr': normalPriceStr, //特价
                                        'normalLinePriceStr': normalLinePriceStr, //原价
                                        'img':_img,
                                        'specs_key1_name':specs_key1_name,
                                        'specs_key1_value':'',
                                        'specs_key2_name':specs_key2_name,
                                        'specs_key2_value':specs_key2_value,
                                        'specs_key3_name':'',
                                        'specs_key3_value':'',
                                        'specs_key4_name':'',
                                        'specs_key4_value':'',
                                        'stockQuantity': _stockQuantity,
                                        'skuId': '' //原变体sku
                                    });
                                    //
                                }
                                //
                            }
                            //
                        }
                        //
                    }else{ //无属性
                        //
                        _shangjia_variants_skus.push({
                            'subsku': '', //自定义变体带属性SKU
                            'normalPriceStr': shangjia_info['_shangjia_minOnSalePriceStr'], //特价
                            'normalLinePriceStr': shangjia_info['_shangjia_minOriginPriceStr'], //原价
                            'img':'',
                            'specs_key1_name':'',
                            'specs_key1_value':'',
                            'specs_key2_name':'',
                            'specs_key2_value':'',
                            'specs_key3_name':'',
                            'specs_key3_value':'',
                            'specs_key4_name':'',
                            'specs_key4_value':'',
                            'stockQuantity': '',
                            'skuId': '' //原变体sku
                        });
                        //
                    }
                    shangjia_info['_shangjia_variants_skus'] = _shangjia_variants_skus;
                    //
                    //
                    shangjia_info['_shangjia_sold'] = $('.title-sale-column .title-info-number').text();
                    let _shangjia_reivew_num_str = $(".title-evaluate-info .title-info-number").text();
                    shangjia_info['_shangjia_reivew_num'] = _shangjia_reivew_num_str;
                    let _shangjia_VideoUrl = $('video').attr('src');
                    shangjia_info['_shangjia_VideoUrl'] = _shangjia_VideoUrl;
                    shangjia_info['_shangjia_about_contact_and_basic_info_link_key'] = _shangjia_about_contact_and_basic_info_link_key;
                    //console.log('shangjia_info');
                    //console.log(shangjia_info);
                    //
                    // 在新标签页中打开指定的 URL
                    var message = {
                        action: 'shangjia_new_tab_process_item_step2_complete',
                        info: '',
                        shangjia_info:shangjia_info
                    };
                    console.log('message');
                    console.log(message);
                    chrome.runtime.sendMessage(message,(msg)=>{
                        console.log('答复',msg)
                        //let msgobj = JSON.parse(msg);
                        //
                        var message = {
                            action: 'closeTab',
                            info: ''
                        };
                        send_message_to_popup(message);
                        //
                    })
                    //
                }
            }
            //
        }
    }
}

//打开指定采集页面开始采集
function process_caiji_taobao_item(){
    console.log('process_caiji_taobao_item s');
    let current_url = window.location.href;
    if(current_url && current_url.indexOf('628398291026') != -1) {
        $('#shop-container-header').hide();
        $('#root-container').hide();
        $('#shop-container-footer').hide();
        $('#gycharm-custom-msg').remove();
        $('ali-bar-new').remove();
         var message = {
             action: 'caiji_item_get_taobao',
             info: ''
         };
         chrome.runtime.sendMessage(message, (msg) => {
             console.log('process_caiji_taobao_item 答复', msg)
             let msgobj = JSON.parse(msg);
             let need_item = msgobj['need_item'];
             //console.log(msgobj['need_item']);
             if (need_item) {
                 //
                 $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;margin-top:20px;'>正在采集:"+need_item['_shangjia_name']+','+need_item['_shangjia_about_contact_and_basic_info_link']+"</div>");
                 //shangjia_insert_iframe_and_get_content_taobao(need_item);
                 shangjia_new_tab_process_item(need_item);
             }else{
                 //
                 let status = msgobj['status'];
                 status = parseInt(status);
                 if(status == 1){
                     $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;margin-top:20px;'>后台采集已暂停，可以在插件工具里开启后台采集</div>");
                    //
                 }else if(status == 3){
                     $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;margin-top:20px;'>目前已有商品在采集，稍等</div>");
                    //
                 }else if(status == 2){
                     console.log('f2');
                     $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;margin-top:20px;'>所有商品已采集完成</div>");
                    //
                 }
             }
         })
        //
    }
}

function xintiao(){
    process_caiji_taobao_item();
}
xintiao();
setInterval(xintiao, 15000);
//
//当tab不活跃时,这个方法实现
/*var lastExecutionTime = 0;
var interval = 20000; // 20秒
function xintiao(timestamp) {
    if (!lastExecutionTime || timestamp - lastExecutionTime >= interval) {
        console.log("Executing...");
        // 在此添加你想要执行的代码
        lastExecutionTime = timestamp;
        //
        process_caiji_taobao_item();
        //
    }

    requestAnimationFrame(xintiao);
}
// 初始启动
requestAnimationFrame(xintiao);*/
//
//send message to pop
function send_message_to_popup(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}
// get popup2content info
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
})
//